﻿Public Class TableItem
    Inherits BaseObject(Of TableItem)
    Implements ITableEntry
    Public Description As String
    Public LoValue As Integer
    Public HiValue As Integer

    Public Sub New()

    End Sub

    Public Sub New(ByVal Description As String)
        Me.Description = Description
    End Sub

    Public Sub New(ByVal Description As String, ByVal LoValue As Integer, ByVal HiValue As Integer)
        Me.Description = Description
        Me.LoValue = LoValue
        Me.HiValue = HiValue
    End Sub

    Public Overrides Sub Read(ByVal File As System.IO.BinaryReader)
        Dim FileVersion As Double = File.ReadDouble
        If FileVersion >= 1 Then
            Me.Description = File.ReadString()
            Me.HiValue = File.ReadInt32
            Me.LoValue = File.ReadInt32
        End If
    End Sub

    Public Overrides Sub Store(ByVal File As System.IO.BinaryWriter)
        File.Write(Version)
        File.Write(Me.Description)
        File.Write(Me.HiValue)
        File.Write(Me.LoValue)
    End Sub

    Protected Overrides Function Version() As Double
        Return 1
    End Function

    Public Function Generate() As String Implements ITableEntry.Generate
        Dim I As Integer = 0
        Dim RolledValue As Integer = 0
        If LoValue > 0 And HiValue > 0 Then
            For I = 1 To LoValue
                RolledValue += D(HiValue)
            Next
            Return CStr(RolledValue) & " " & Me.Description
        Else
            Return Me.Description
        End If
    End Function
End Class

Public Interface ITableEntry
    Inherits IInterfaceObject
    Function Generate() As String
End Interface

Public Class RandomTable
    Inherits InterfaceList(Of RandomTable, ITableEntry)
    Implements ITableEntry

    Public Overloads Function Add() As TableItem
        Return New TableItem
    End Function

    Public Overloads Sub Add(ByVal ParamArray Items() As String)
        Dim I As Integer
        For I = 0 To UBound(Items, 1)
            Me.Add(New TableItem(Items(I)))
        Next
    End Sub

    Public Overloads Function Generate() As String Implements ITableEntry.Generate
        Dim Roll As Integer = D(Me.Count) - 1
        If Me.Count = 0 Then Return ""
        Return Me(Roll).Generate
    End Function

    Public Overloads Function Generate(ByVal Roll As Integer) As String
        Dim tItem As TableItem = New TableItem
        For Each tItem In Me
            If Roll <= tItem.HiValue And Roll >= tItem.LoValue Then
                Exit For
            End If
        Next
        Return tItem.Description
    End Function
End Class