﻿Imports RSC_CoreModule

Public Class RandomIslands
    Public IslandCoast As New RandomTable
    Public IslandInhabited As New RandomTable
    Public IslandSettlement As New RandomTable
    Public IslandInterest As New RandomTable
    Public IslandCreature As New RandomTable

    Public Sub New()
        SetupClass()
    End Sub

    Public Function Generate() As String
        Dim SB As New System.Text.StringBuilder
        Dim TempS As String
        Dim Roll As Integer
        Dim I As Integer
        TempS = Me.IslandCoast.Generate
        If TempS <> " " Then
            SB.Append(TempS)
            SB.Append(", ")
        End If
        TempS = Me.IslandInhabited.Generate
        SB.Append(TempS)
        If InStr(TempS, "No Settlements") = 0 Then
            SB.Append(" ")
            SB.Append(Me.IslandSettlement.Generate)
        End If
        SB.Append(" with the following; ")
        TempS = Me.IslandInterest.Generate
        SB.Append(TempS)
        Roll = D(3)
        For I = 1 To Roll
            SB.Append(", ")
            TempS = Me.IslandCreature.Generate
            SB.Append(TempS)
        Next I
        Return SB.ToString
    End Function

    Private Sub SetupClass()
        IslandCoast.Add("Ringed by Reefs", "Ringed by Reefs", "Ringed by beaches", "Ringed by High Cliffs", " ", " ")
        IslandInhabited.Add("No Settlements", "No Settlements", "No Settlements", "Small Villages", "Town", "City")
        IslandSettlement.Add("at war with nearly island", "with Sage resident", "suffering Pirates raids", "lives in Harmony", "attacked by cruel monster", "with Gruesome Secret", "with Odd Population", "under the sway of evil", "that has never seen outsiders", "that a Personal domain of a diety", "with Games underway")
        IslandInterest.Add("Natural Fountain", "Waterfalls", "Statues", "Forest full of fae", "Large Caves", "Ancient Mines", "Old Road", "Ruined fortress", "Secretive Tower", "Remote Temple", "Territorial markers", "Chasm/Rope Bridge", "Underwater site", "Carved Mountain", "Witches cave/glen", "Roll Two")
        SetupCreature()
    End Sub

    Private Sub SetupCreature()
        Dim Table As New RandomTable
        Dim SubTable As RandomTable
        Dim SubChart As RandomTable
        IslandCreature.Add(Table)

        SubTable = New RandomTable
        SubTable.Add("Ape Men", "Elder Nobles", "Bee-folk", "Centaurs", "Derros", "Gnolls", "Lionfolk", "Hill Giants", "Elves", "Antmen", "Ogres", "Satyrs", "Serpent Men", "Dark Lords", "Fae", "Stone Giants", "Gnomes", "Troglodytes", "Cavemen")
        Table.Add(SubTable)
        Table.Add(SubTable)

        SubTable = New RandomTable

        SubChart = New RandomTable
        SubChart.Add("Cerberus", "Chimera", "Cockatrice", "Dragon", "Giant", "Titan")
        SubTable.Add(SubChart)

        SubChart = New RandomTable
        SubChart.Add("Dire Boars", "Giant Bull", "Giant Eagles", "Giant Ram", "Giant Scorpions", "Giant Spiders")
        SubTable.Add(SubChart)

        SubChart = New RandomTable
        SubChart.Add("Gorgon", "Griffins", "Harpies", "Hydra", "Lamia", "Manticore")
        SubTable.Add(SubChart)

        SubChart = New RandomTable
        SubChart.Add("Minotaur", "Giant Insects", "Pegasus", "Phoenix", "Pterodactyls", "Rocs")
        SubTable.Add(SubChart)

        SubChart = New RandomTable
        SubChart.Add("Sirens", "Sphinx", "Stirges", "Shambling Mounds", "Tyrannosaurus", "Unicorn")
        SubTable.Add(SubChart)

        Table.Add(SubTable)
        Table.Add(SubTable)

        SubTable = New RandomTable
        SubTable.Add("Demon", "Wights", "Ghosts", "Hags", "Shadows")
        Table.Add(SubTable)

        SubTable = New RandomTable
        SubTable.Add("Bronze Bull", "Bronze Colossus", "Iron Golems", "Stone Golems", "Mummies", "Skeleton", "Clay Golems", "Bronze Fire Hounds", "Animated Vines")
        Table.Add(SubTable)


    End Sub

End Class

