﻿Option Strict Off
Imports RSC_CoreModule

Public Class RandomStrongHolds
    Public SH_Occupant As New RandomTable
    Public SH_Guard_Lord As New RandomTable
    Public SH_Guard_SH As New RandomTable
    Public SH_Guard_Wiz As New RandomTable
    Public SH_Guard_Necro As New RandomTable
    Public SH_Guard_Pat As New RandomTable
    Public SH_Guard_EHP As New RandomTable

    Public Sub New()
        SetupClass()
    End Sub

    Public Function Generate() As String
        Dim SB As New System.Text.StringBuilder
        Dim TempS As String
        Dim Roll As Integer
        Dim DoFighter As Boolean = False
        Dim DoMagicUser As Boolean = False
        Dim DoCleric As Boolean = False
        Dim I As Integer = 0
        TempS = Me.SH_Occupant.Generate
        If TempS <> " " Then
            SB.Append(TempS)
        End If
        Roll = D(4)
        Select Case TempS
            Case "9th Level Fighter"
                TempS = Me.SH_Guard_Lord.Generate
                DoFighter = True
            Case "8th Level Fighter"
                TempS = Me.SH_Guard_SH.Generate
                DoFighter = True
            Case "11th Level Wizard"
                TempS = Me.SH_Guard_Wiz.Generate
                DoMagicUser = True
            Case "10th Level Wizard"
                TempS = Me.SH_Guard_Necro.Generate
                DoMagicUser = True
            Case "8th Level Priest"
                TempS = Me.SH_Guard_Pat.Generate
                DoCleric = True
            Case "9th Level Priest"
                TempS = Me.SH_Guard_EHP.Generate
                DoCleric = True
        End Select
        Dim Data As String() = TempS.Split(",")
        Roll = D(Val(Data(1)))
        SB.Append(" guarded by ")
        SB.Append(Roll)
        SB.Append(" ")
        SB.Append(Data(0))
        SB.Append(" with ")
        SB.Append(_3D6() * 10)
        SB.Append(" men ")
        If DoFighter Then
            Roll = D(100)
            If Roll < 25 Then
                SB.Append(" with ")
                SB.Append(D(4) + 4)
                SB.Append("th Level Magic User")
            End If
            Roll = D(100)
            If Roll < 50 Then
                SB.Append(" with ")
                SB.Append(D(4) + 2)
                SB.Append("th Level Cleric")
            End If
        End If
        If DoMagicUser Then
            Roll = D(100)
            If Roll < 25 Then
                SB.Append(" with ")
                SB.Append(D(4) + 4)
                SB.Append("th Level Fighter")
            End If
            Roll = D(100)
            If Roll < 50 Then
                SB.Append(" with ")
                SB.Append(D(4) + 3)
                SB.Append("th Level Magic User")
            End If
        End If
        If DoCleric Then
            Roll = D(100)
            If Roll < 50 Then
                Roll = _1D6()
                For I = 1 To Roll
                    SB.Append(" with ")
                    SB.Append(D(4) + 3)
                    SB.Append("th Level Cleric")
                Next I
            End If
        End If
        Return SB.ToString
    End Function

    Private Sub SetupClass()
        Me.SH_Occupant.Add("9th Level Fighter", "8th Level Fighter", "11th Level Wizard", "10th Level Wizard", "8th Level Priest", "9th Level Priest")
        Me.SH_Guard_Lord.Add("7th Level Fighters,8", "Griffons, 6", "6th Level Fighters,10", "Giants,4")
        Me.SH_Guard_SH.Add("6th Level Fighters,8", "Rocs w/ 4th Level Fighters, 4", "Ogres,4", "5th Level Fighter,10")
        Me.SH_Guard_Wiz.Add("Dragons,4", "Type 6 Demons,4", "Wyverns,4", "Basilisks,4")
        Me.SH_Guard_Necro.Add("Chimeras,4", "Manitcores,6", "Lycantropes,12", "Gargoyles,12")
        Me.SH_Guard_Pat.Add("4th Level Fighters,20", "8th Level Fighters,6", "Treants,10", "Hippogriffs,8")
        Me.SH_Guard_EHP.Add("Trolls,10", "Vampires, 6", "White Apes,20", "Spectries,10")

    End Sub


End Class
